
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# hlo tarkastusfunktiot
# HUOM: ryhma_id vlitetn viittauksena koska sit voidaan joutua muuttamaan

function hlo_ok(&$msg,$id,$paivystys_id,$nimi,&$ryhma_id,$hlo_tila_id,
		$hlo_asema_id,$jarjesto_id) {
  global $table;

  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # tarpeelliset kentt
  if ($nimi == '') {
    $msg = 'Nimi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # paivystys, ryhma, hlo_tila, hlo_asema, jarjesto oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("ryhma","kutsu",$ryhma_id) == '') {
    $msg = "Ryhm $ryhma_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("hlo_tila","",$hlo_tila_id) == '') {
    $msg = "Henkiln tilakoodia $hlo_tila_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("hlo_asema","",$hlo_asema_id) == '') {
    $msg = "Henkiln tilakoodia $hlo_tila_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("jarjesto","",$jarjesto_id) == '') {
    $msg = "Jrjest $jarjesto_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE nimi = '$nimi'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tmn niminen henkil on jo olemassa (id=$dup).";
    $msg .= $tail;
    return 2;
  } 

  # jos ryhma ja paivystys on asetettu, niiden tytyy tsmt mod 0.
  if (($ryhma_id != '1') && ($paivystys_id != '0')) {
    if (tab_col_id("ryhma","paivystys_id",$ryhma_id) != $paivystys_id) {
      $msg = "Annetut ryhm($ryhma_id) ja operaatio($paivystys_id) eivt
 sovi yhteen. Ryhm palautettu oletustilaan.";
      $ryhma_id = 1;
      $ret = 1;
    }
  }
  
  return $ret;
}

function hlo_add_ok(&$msg,$paivystys_id,$nimi,&$ryhma_id,$hlo_tila_id,
		    $hlo_asema_id,$jarjesto_id) {
  return hlo_ok($msg,'',$paivystys_id,$nimi,$ryhma_id,$hlo_tila_id,
		$hlo_asema_id,$jarjesto_id);
}

function hlo_save_ok(&$msg,$id,$paivystys_id,$nimi,&$ryhma_id,$hlo_tila_id,
		     $hlo_asema_id,$jarjesto_id) {
  return hlo_ok($msg,$id,$paivystys_id,$nimi,$ryhma_id,$hlo_tila_id,
		$hlo_asema_id,$jarjesto_id);
}

function hlo_set_ryhma_id_ok(&$msg,$id,$ryhma_id) {
  $paivystys_id = tab_col_id("hlo","paivystys_id",$id);
  $nimi = tab_col_id("hlo","nimi",$id);
  # ryhma_id
  $hlo_tila_id = tab_col_id("hlo","hlo_tila_id",$id);
  $hlo_asema_id = tab_col_id("hlo","hlo_asema_id",$id);
  $jarjesto_id = tab_col_id("hlo","jarjesto_id",$id);
  return hlo_ok($msg,$id,$paivystys_id,$nimi,$ryhma_id,$hlo_tila_id,
		$hlo_asema_id,$jarjesto_id);
}

function hlo_set_hlo_tila_id_ok(&$msg,$id,$hlo_tila_id) {
  $paivystys_id = tab_col_id("hlo","paivystys_id",$id);
  $nimi = tab_col_id("hlo","nimi",$id);
  $ryhma_id = tab_col_id("hlo","ryhma_id",$id);
  # hlo_tila_id
  $hlo_asema_id = tab_col_id("hlo","hlo_asema_id",$id);
  $jarjesto_id = tab_col_id("hlo","jarjesto_id",$id);
  return hlo_ok($msg,$id,$paivystys_id,$nimi,$ryhma_id,$hlo_tila_id,
		$hlo_asema_id,$jarjesto_id);
}

# here, we have no hlo.id .
# XXX possibly some extra checks possible?
function hlo_set_hlo_tila_id_by_ryhma_id_ok(&$msg,$ryhma_id,$hlo_tila_id) {
  if (tab_col_id("ryhma","kutsu",$ryhma_id) == '') {
    $msg = "Ryhm $ryhma_id ei lydy.";
    return 2;
  }
  if (tab_col_id("hlo_tila","",$hlo_tila_id) == '') {
    $msg = "Henkiln tilakoodia $hlo_tila_id ei lydy.";
    return 2;
  }

  return 0;
}

function hlo_set_hlo_asema_id_ok(&$msg,$id,$hlo_asema_id) {
  $paivystys_id = tab_col_id("hlo","paivystys_id",$id);
  $nimi = tab_col_id("hlo","nimi",$id);
  $ryhma_id = tab_col_id("hlo","ryhma_id",$id);
  $hlo_tila_id = tab_col_id("hlo","hlo_tila_id",$id);
  # hlo_asema_id
  $jarjesto_id = tab_col_id("hlo","jarjesto_id",$id);
  return hlo_ok($msg,$id,$paivystys_id,$nimi,$ryhma_id,$hlo_tila_id,
		$hlo_asema_id,$jarjesto_id);
}

function hlo_remove_ok(&$msg,$id) {
  # jos viittauksia laitteissa tai tavarassa, ei voi poistaa
  $dup = ota_yksi("SELECT COUNT(*) FROM laite WHERE hlo_id = $id");
  if ($vahvuus != 0) {
    $msg = "Henkiln on viel viittauksia $dup viestivlineess eik henkil
voida poistaa ennen kuin nm viittaukset on siivottu.";
    return 2;
  }
  $dup = ota_yksi("SELECT COUNT(*) FROM tavara WHERE hlo_id = $id");
  if ($vahvuus != 0) {
    $msg = "Henkiln on viel viittauksia $dup tavarassa eik henkil
voida poistaa ennen kuin nm viittaukset on siivottu.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: hlo-ok.php,v 1.4 2009/02/02 20:26:35 riku Exp $ -->
