
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# jarjesto tarkastusfunktiot

function jarjesto_ok(&$msg,$id,$jarjesto,$paivystys_id) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if (($id == "1") || ($id == "2")) {
    $msg = "Jrjestt numeroilla 1 ja 2 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($jarjesto == '') {
    $msg = 'Jrjestn nimi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # paivystys oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE jarjesto = '$jarjesto'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tllainen jrjest on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function jarjesto_add_ok(&$msg,$jarjesto,$paivystys_id) {
  return jarjesto_ok($msg,'',$jarjesto,$paivystys_id);
}

function jarjesto_save_ok(&$msg,$id,$jarjesto,$paivystys_id) {
  return jarjesto_ok($msg,$id,$jarjesto,$paivystys_id);
}

function jarjesto_remove_ok(&$msg,$id) {
  $msg = '';

  # jrjestj 1 ja 2 ei voi poistaa
  if (($id == "1") || ($id == "2")) {
    $msg = "Jrjestj numeroilla 1 ja 2 ei voi poistaa.";
    return 2;
  }

  # jos jrjestn on viittauksia henkiliss, laitteissa tai tavarassa,
  # sit ei voi poistaa
  $ref = ota_yksi("SELECT COUNT(*) FROM hlo WHERE jarjesto_id = $id");
  if ($ref != 0) {
    $msg = "Thn jrjestn on viittauksia $ref eri henkilss. Sit ei voi
 poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM laite WHERE jarjesto_id = $id");
  if ($ref != 0) {
    $msg = "Thn jrjestn on viittauksia $ref eri viestivlineess.
 Sit ei voi poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM tavara WHERE jarjesto_id = $id");
  if ($ref != 0) {
    $msg = "Thn jrjestn on viittauksia $ref eri tavarassa.
 Sit ei voi poistaa ennen kuin viittaukset on siivottu.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: jarjesto-ok.php,v 1.4 2009/02/05 16:32:30 riku Exp $ -->
