
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# kayttaja tarkastusfunktiot

function kayttaja_ok(&$msg,$id,$username,$paivystys_id) {
  global $table;
  
  $msg = '';
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Kyttj numero 1 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($username == '') {
    $msg = 'Kyttjtunnus on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # paivystyksen oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE username = '$username'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tm kyttjtunnus on jo olemassa (id=$dup)";
    $msg .= $tail;
    return 2;
  } 

  return 0;
}

function kayttaja_add_ok(&$msg,$username,$paivystys_id) {
  return kayttaja_ok($msg,'',$username,$paivystys_id);
}

function kayttaja_save_ok(&$msg,$id,$username,$paivystys_id) {
  return kayttaja_ok($msg,$id,$username,$paivystys_id);
}

function kayttaja_remove_ok(&$msg,$id) {
  $msg = '';

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Kyttj numero 1 on suojattu. Ei voi poistaa";
    return 2;
  }

  # roottia ei voi poistaa
  if (tab_col_id("kayttajat","username",$id) == "root") {
    $msg = "Kyttjtunnusta 'root' ei voi poistaa.";
    return 2;
  }

  return 0;
}

?>

<!-- RCS $Id: kayttaja-ok.php,v 1.2 2009/02/05 10:52:59 riku Exp $ -->
