
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# XXX tarkastusfunktiot
# HUOM: ryhma_id vlitetn viittauksena koska sit voidaan joutua muuttamaan

function XXX_ok(&$msg,$id,$paivystys_id,$nimi,&$ryhma_id,$XXX_tila_id,
		$XXX_asema_id,$jarjesto_id) {
  global $table;

  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Koodi numero 1 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($nimi == '') {
    $msg = 'Nimi on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # paivystys, ryhma, XXX_tila, XXX_asema, jarjesto oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("ryhma","kutsu",$ryhma_id) == '') {
    $msg = "Ryhm $ryhma_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("XXX_tila","",$XXX_tila_id) == '') {
    $msg = "Henkiln tilakoodia $XXX_tila_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("XXX_asema","",$XXX_asema_id) == '') {
    $msg = "Henkiln tilakoodia $XXX_tila_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("jarjesto","",$jarjesto_id) == '') {
    $msg = "Jrjest $jarjesto_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM $table
WHERE nimi = '$nimi'
      $id_sql
");
  if ($dup != '') {
    $msg = "Tmn niminen henkil on jo olemassa (id=$dup).";
    $msg .= $tail;
    return 2;
  } 

  # jos ryhma ja paivystys on asetettu, niiden tytyy tsmt mod 0.
  if (($ryhma_id != '1') && ($paivystys_id != '0')) {
    if (tab_col_id("ryhma","paivystys_id",$ryhma_id) != $paivystys_id) {
      $msg = "Annetut ryhm($ryhma_id) ja operaatio($paivystys_id) eivt
 sovi yhteen. Ryhm palautettu oletustilaan.";
      $ryhma_id = 1;
      $ret = 1;
    }
  }
  
  return $ret;
}

function XXX_add_ok(&$msg,$paivystys_id,$nimi,&$ryhma_id,$XXX_tila_id,
		    $XXX_asema_id,$jarjesto_id) {
  return XXX_ok($msg,'',$paivystys_id,$nimi,$ryhma_id,$XXX_tila_id,
		$XXX_asema_id,$jarjesto_id);
}

function XXX_save_ok(&$msg,$id,$paivystys_id,$nimi,&$ryhma_id,$XXX_tila_id,
		     $XXX_asema_id,$jarjesto_id) {
  return XXX_ok($msg,$id,$paivystys_id,$nimi,$ryhma_id,$XXX_tila_id,
		$XXX_asema_id,$jarjesto_id);
}

function XXX_remove_ok(&$msg,$id) {

  # kovakoodattu
  if ($id == "1") {
    $msg = "Koodia numero 1 ei voi poistaa.";
    return 2;
  }

  # jos viittauksia laitteissa tai tavarassa, ei voi poistaa
  $dup = ota_yksi("SELECT COUNT(*) FROM laite WHERE XXX_id = $id");
  if ($vahvuus != 0) {
    $msg = "Henkiln on viel viittauksia $dup viestivlineess eik henkil
voida poistaa ennen kuin nm viittaukset on siivottu.";
    return 2;
  }
  $dup = ota_yksi("SELECT COUNT(*) FROM tavara WHERE XXX_id = $id");
  if ($vahvuus != 0) {
    $msg = "Henkiln on viel viittauksia $dup tavarassa eik henkil
voida poistaa ennen kuin nm viittaukset on siivottu.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: pohja-ok.php,v 1.4 2009/02/05 16:43:14 riku Exp $ -->
