
<?php

# sanity check functions for database additions, modifications and
# deletions.
# general format is ret = table_what_ok(&$msg,$id, ...)
# msg is error/warning message
# id is the main id of the record in question, new record => id = ''
# return codes:
#  0 (all ok, msg undefined)
#  1 (warnings in msg)
#  2 (fatal, reason in msg)

# ryhma tarkastusfunktiot
# HUOM: paikka_id vlitetn viitteell koska sit voidaan modifioida
# tarkastuksen kuluessa.

function ryhma_ok(&$msg,$id,$paivystys_id,&$paikka_id,$ryhma_tila_id,
		  $verkko_id,$kutsu) {
  global $table;
  
  $msg = '';
  $ret = 0;
  
  if ($id != "") {
    $id_sql = "AND id != $id";
    $modify = 1;
    $tail = " Ei voi muuttaa.";
  } else {
    $modify = 0;
    $tail = " Ei voi list.";
  }

  # kovakoodatut tietueet
  if ($id == "1") {
    $msg = "Ryhm numero 1 on suojattu.";
    $msg .= $tail;
    return 2;
  }

  # tarpeelliset kentt
  if ($kutsu == '') {
    $msg = 'Kutsu on pakollinen tieto.';
    $msg .= $tail;
    return 2;
  }

  # paivystys, paikka, ryhma_tila, verkko oltava olemassa
  # tai soveltuvin osin 0
  if (tab_col_id_none("paivystys","nimi",$paivystys_id) == '') {
    $msg = "Operaatiota $paivystys_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("paikka","",$paikka_id) == '') {
    $msg = "Sijaintikoodia $paikka_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("ryhma_tila","",$ryhma_tila_id) == '') {
    $msg = "Tilakoodia $ryhma_tila_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  if (tab_col_id("verkko","",$verkko_id) == '') {
    $msg = "Verkkoa $verkko_id ei lydy.";
    $msg .= $tail;
    return 2;
  }
  
  # duplikaatit
  $dup = ota_yksi("
SELECT id
FROM ryhma
WHERE kutsu = '$kutsu'
      AND (paivystys_id = 0 OR paivystys_id = $paivystys_id)
      $id_sql
");
  if ($dup != '') {
    $msg = "Ryhm $kutsu on jo olemassa tss tai kaikissa operaatioissa
 (id=$dup).";
    $msg .= $tail;
    return 2;
  }

  # jos paikka ei sovi yhteen paivystys_id:n kanssa, resetoi se.
  $paikka_paivystys_id
    = ota_yksi("SELECT paivystys_id FROM paikka WHERE id = $paikka_id");
  if ($paikka_paivystys_id != 0) {
    if ($paivystys_id != 0) {
      if ($paivystys_id != $paikka_paivystys_id) {
	$paikka_id = "1";
	$msg .= " Sijainti vaihdettu.";
	$ret = 1;
      }
    }
  }

  # jos ryhmss on henkilkuntaa, vaihdetaan heilt pivystys jos tarpeen.
  $count1 = ota_yksi("
SELECT COUNT(*)
FROM hlo
WHERE ryhma_id = $id AND paivystys_id != $paivystys_id
");
  if ($count1 != 0) {
    $sql1 = "
UPDATE hlo
SET paivystys_id=$paivystys_id
WHERE ryhma_id=$id
";
    my_mysql_query($sql1);
    loki($sql1);
    $msg .= " $count1 henkiln operaatio vaihdettu automaattisesti.";
    $ret = 1;
  }

  # jos ryhmss on laitteita tai tavaraa,
  # vaihdetaan niiltkin pivystys jos tarpeen.
  $count1 = ota_yksi("
SELECT COUNT(*)
FROM laite
WHERE ryhma_id=$id AND paivystys_id != $paivystys_id
");
  if ($count1 != 0) {
    $sql1 = "
UPDATE laite
SET paivystys_id=$paivystys_id
WHERE ryhma_id=$id
";
    my_mysql_query($sql1);
    loki($sql1);
    $msg .= " $count1 viestivlineen operaatio vaihdettu automaattisesti.";
    $ret = 1;
  }
  #
  $count1 = ota_yksi("
SELECT COUNT(*)
FROM tavara
WHERE ryhma_id=$id AND paivystys_id != $paivystys_id
");
  if ($count1 != 0) {
    $sql1 = "
UPDATE tavara
SET paivystys_id=$paivystys_id
WHERE ryhma_id=$id AND paivystys_id != $paivystys_id
";
    my_mysql_query($sql1);
    loki($sql1);
    $msg .= " $count1 tavaran operaatio vaihdettu automaattisesti.";
    $ret = 1;
  }
  
  return $ret;
}

function ryhma_add_ok(&$msg,$paivystys_id,&$paikka_id,$ryhma_tila_id,
		      $verkko_id,$kutsu) {
  return ryhma_ok($msg,'',$paivystys_id,$paikka_id,$ryhma_tila_id,$verkko_id,
		  $kutsu);
}

function ryhma_save_ok(&$msg,$id,$paivystys_id,&$paikka_id,$ryhma_tila_id,
		       $verkko_id,$kutsu) {
  return ryhma_ok($msg,$id,$paivystys_id,$paikka_id,$ryhma_tila_id,$verkko_id,
		  $kutsu);
}

function ryhma_set_ryhma_tila_id_ok(&$msg,$id,$ryhma_tila_id) {
  $paivystys_id = tab_col_id("ryhma","paivystys_id",$id);
  $paikka_id = tab_col_id("ryhma","paikka_id",$id);
  $verkko_id = tab_col_id("ryhma","verkko_id",$id);
  $kutsu = tab_col_id("ryhma","kutsu",$id);
  return ryhma_ok($msg,$id,$paivystys_id,$paikka_id,$ryhma_tila_id,$verkko_id,
		  $kutsu);
}

function ryhma_set_ryhma_paikka_id_ok(&$msg,$id,$ryhma_paikka_id) {
  $paivystys_id = tab_col_id("ryhma","paivystys_id",$id);
  $tila_id = tab_col_id("ryhma","tila_id",$id);
  $verkko_id = tab_col_id("ryhma","verkko_id",$id);
  $kutsu = tab_col_id("ryhma","kutsu",$id);
  return ryhma_ok($msg,$id,$paivystys_id,$paikka_id,$ryhma_tila_id,$verkko_id,
		  $kutsu);
}

function ryhma_set_ok(&$msg,$id) {
  $paivystys_id = tab_col_id("ryhma","paivystys_id",$id);
  $paikka_id = tab_col_id("ryhma","paikka_id",$id);
  $tila_id = tab_col_id("ryhma","tila_id",$id);
  $verkko_id = tab_col_id("ryhma","verkko_id",$id);
  $kutsu = tab_col_id("ryhma","kutsu",$id);
  return ryhma_ok($msg,$id,$paivystys_id,$paikka_id,$ryhma_tila_id,$verkko_id,
		  $kutsu);
}

function ryhma_remove_ok(&$msg,$id) {
  $msg = '';
  
  # kovakoodattu
  if ($id == "1") {
    $msg = "Ryhm numero 1 ei voi poistaa.";
    return 2;
  }

  # jos ryhmss on henkilkuntaa, tapahtumia, laitteita tai tavaraa
  # sit ei voi poistaa
  $vahvuus = ota_yksi("SELECT COUNT(*) FROM hlo WHERE ryhma_id = $id");
  if ($vahvuus != 0) {
    $msg = "Ryhmss on viel $vahvuus henkil eik ryhm voi poistaa ennen
 kuin nm henkilt on poistettu ryhmst.";
    return 2;
  }
  $tap = ota_yksi("SELECT COUNT(*) FROM tap WHERE ryhma_id = $id");
  if ($tap != 0) {
    $msg = "Ryhmlle on viel kirjattuna $tap tapahtumaa eik ryhm voi
 poistaa ennen kuin nm tapahtumat on poistettu ryhmlt.";
    return 2;
  }
  $laite = ota_yksi("SELECT COUNT(*) FROM laite WHERE ryhma_id = $id");
  if ($laite != 0) {
    $msg = "Ryhmll on viel hallussa $laite viestivlinett eik ryhm voi
 poistaa ennen kuin nm on poistettu ryhmlt.";
    return 2;
  }
  $ref = ota_yksi("SELECT COUNT(*) FROM tavara WHERE ryhma_id = $id");
  if ($ref != 0) {
    $msg = "Ryhmll on viel hallussa $ref tavaraa eik ryhm voi
 poistaa ennen kuin nm on poistettu ryhmlt.";
    return 2;
  }
  
  return 0;
}

?>

<!-- RCS $Id: ryhma-ok.php,v 1.9 2009/02/05 16:45:12 riku Exp $ -->
